import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Missile here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Missile extends Actor
{ 
    
    public Missile (int xSpeed)
    {
    this.xSpeed = xSpeed;
    }
    /**
     * Act - do whatever the Missile wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        setLocation(getX()-xSpeed,getY()-5);
              
        Alien alien= (Alien)getOneIntersectingObject(Alien.class);
        if(alien!=null)
        {
            Explosion explosion=new Explosion();
            getWorld().addObject(explosion,getX(),getY());
            GreenfootWorld world = (GreenfootWorld)getWorld();
            world.removeObject(alien);
            if (alien instanceof EliteAlien)
            {
                world.addToScore(10);  
            }
            else if (alien instanceof MegaBomber)
            {
                world.addToScore(25);
            }
            else
            {
                world.addToScore(5);
            }
            double random = Math.random();
            if (random < 0.025)
            {
               world.addObject(new Upgrades(),getX(),getY());
            }
            else if (random < 0.075)
            {
               world.addObject(new LaserUpgrade(),getX(),getY());
            }
            else if (random <0.1)
            {
            world.addObject(new ShieldUpgrade(),getX(),getY());
            }
            world.removeObject(this);
            return;
        }    
       
             
        Asteroid asteroid= (Asteroid)getOneIntersectingObject(Asteroid.class);
        if(asteroid!=null)
        {
            Explosion explosion=new Explosion();
            getWorld().addObject(explosion,getX(),getY());
            GreenfootWorld world = (GreenfootWorld)getWorld();
            world.addToScore(5);
            world.removeObject(asteroid);
            world.addObject(new Asteroid(true,true),getX(),getY());
            world.addObject(new Asteroid(false,true),getX(),getY());
            world.removeObject(this);
            return;
        }    
        
        if (getY()==0)
        {
        getWorld().removeObject (this);
        return;
        }     
    }    

    private int xSpeed;

}


