import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


 /**
 ** GreenfootInvaders version 1.00
 **/
public class Rocket extends Actor
{ 


    public Rocket ()
    {
        shieldCount.addValue(100);
        timeSinceCreated=System.currentTimeMillis();
    }

    public void explode ()
    {
        GreenfootWorld world = (GreenfootWorld)getWorld();
        world.addObject(new Explosion(),getX(),getY());
        world.removeObject(shieldCount);
        world.addToScore(-10);
        numberOfLives=numberOfLives-1;
        world.spydorDestroyed();
        world.removeObject(this);
 
 
    }
            
    public void act() 
    {
       getWorld().addObject(shieldCount,20,2);
       if (Greenfoot.isKeyDown("left"))
       {
    
        setLocation(getX()-3,getY());
        
        }
    
       if (System.currentTimeMillis()-timeSinceCreated<3000)
        {
                invincibility = true;
          }
             else
             {
                invincibility = false;
             }
    
    if (Greenfoot.isKeyDown("right"))
    {
    
    setLocation(getX()+3,getY());
    
    }
    
    
    if (Greenfoot.isKeyDown("space")) 
    {
        if(System.currentTimeMillis()-timeLastFiredMissile>1000)
        {
            if (laserUpgrade)
            {
                Missile missile1 = new Missile(2);
                Missile missile2 = new Missile(-2);
                getWorld().addObject(missile1,getX(),getY());
                getWorld().addObject(missile2,getX(),getY());
            }
          Missile missile = new Missile(0);
          getWorld().addObject(missile,getX(),getY());
          timeLastFiredMissile=System.currentTimeMillis();
           Greenfoot.playSound("scifi002.wav");
        }

      }
      
    if (Greenfoot.isKeyDown("w"))
    {
            if(System.currentTimeMillis()-timeLastFiredSideBomb>1000)
        {
        timeLastFiredSideBomb=System.currentTimeMillis();
                   
        SideBomb sideBomb1=new SideBomb(true);
    getWorld().addObject(sideBomb1,getX(),getY());
    SideBomb sideBomb2=new SideBomb(false);
    getWorld().addObject(sideBomb2,getX(),getY());
        Greenfoot.playSound("scifi048.wav");
    }
            
}

    if (Greenfoot.isKeyDown("s") && shieldCount.getValue()>=30)
    {
      shieldCount.subtractValue(2);       
      shieldOn=(true);
      setImage("rocket-shield.png");
    }
     else
    {   
        if (shieldCount.getValue()<=maxShieldCount)
        {
            shieldCount.addValue(1); 
        }
        if (shieldCount.getValue()>=minShieldCount)
        {
        shieldCount=shieldCount;
        }
        
        shieldOn=(false);
        
       if (invincibility)
       {
          setImage("rocket-invincible.png");
        }
        else
        {
            setImage("rocket.png");
        }
   }



            Alien alien= (Alien)getOneIntersectingObject(Alien.class);
       if(alien!=null)
       {
           getWorld().addObject (new Explosion(),alien.getX(),alien.getY());
           getWorld().removeObject(alien);  
           if (!isShieldOn()&& !invincibility)
               {
               explode();
               }
               if (isShieldOn())
               {
                
                   shieldCount.subtractValue(10);
                }
               
               return;
        
  
            }
            
            if (System.currentTimeMillis()- timeSinceLaserUpgrade>10000)
            {
            laserUpgrade=false;
            }
        
            if (System.currentTimeMillis() - timeSinceLastShieldUpgrade>20000)
            {
            maxShieldCount = 99;
            }
        
        }       

    public void invincibilityUpgrade()
    {
    timeSinceCreated=System.currentTimeMillis();
    }
            
    boolean isShieldOn()
    {
     return shieldOn;
    }
    
 boolean isInvincibilityOn()
  {
   return invincibility;
  }
  
  public void laserUpgrade()
  {
    laserUpgrade = true;
    timeSinceLaserUpgrade = System.currentTimeMillis();
  }
    
  public void shieldUpgrade()
  {
      maxShieldCount = 199;
      shieldCount.setValue(199);
      timeSinceLastShieldUpgrade = System.currentTimeMillis();
   }
  
   
    long timeLastFiredMissile;
    long timeLastFiredSideBomb;
    Score shieldCount= new Score("Shield Level ");
    boolean shieldOn;
    double maxShieldCount=99;
    double minShieldCount=0;
    int numberOfLives;
    boolean invincibility = false;
    long timeSinceCreated;
    boolean laserUpgrade;
    long timeSinceLaserUpgrade;
    long timeSinceLastShieldUpgrade;
    
    
}



